<?php

/**
 * Profile Blogs 1.1 - Filip Klar 2011-2012
 */

if(!defined("IN_MYBB")) {
	die("Direct initialization of this file is not allowed.<br />Please make sure IN_MYBB is defined.");
}

$plugins->add_hook("member_profile_start", "profileblogs_box");
$plugins->add_hook("index_start", "profileblogs_latest");


function profileblogs_info() {
	global $lang;
	$lang->load("profileblogs");
	return array(
		"name"			=> $lang->profileblogsName,
		"description"	=> $lang->profileblogsDescription,
		"website"		=> "http://fklar.pl",
		"author"		   => "Filip Klar",
		"authorsite"	=> "http://fklar.pl",
		"version"		=> "1.2",
		"guid" 			=> "e1d9f39ad89f351064c97471377cd233",
		"compatibility" => "16*"
	);
}

function profileblogs_install() {
	global $db,$lang;
	$lang->load("profileblogs");
	
	$db->query("CREATE TABLE `".TABLE_PREFIX."blogposts`(
	`pid` INT NOT NULL AUTO_INCREMENT,
	`uid` INT NOT NULL,
	`dateline` BIGINT NOT NULL,
	`subject` TEXT NOT NULL,
	`message` TEXT NOT NULL,
	`ipaddress` TEXT NOT NULL,
	PRIMARY KEY (`pid`)) ENGINE=MYISAM CHARACTER SET utf8 COLLATE utf8_general_ci"
	);
	
	$profileblogs_group = array(
		"gid" 			=> "NULL",
		"name" 			=> "profileblogs",
		"title" 			=> $lang->profileblogsName,
		"description" 	=> $lang->profileblogsDescSet,
		"disporder" 	=> "25",
		"isdefault" 	=> "yes",
	);
	$db->insert_query("settinggroups", $profileblogs_group);
	$gid = $db->insert_id();
	
	$profileblogs_windowname = array(
		"sid"				=> "NULL",
		"name"			=> "profileblogs_windowname",
		"title"			=> $lang->profileblogsWindowName,
		"description"	=> "",
		"optionscode"	=> "text",
		"value"			=> "Blog",
		"disporder"		=> "1",
		"gid"				=> intval($gid),
	);
	$db->insert_query("settings", $profileblogs_windowname);
	
	$profileblogs_number = array(
		"sid"				=> "NULL",
		"name"			=> "profileblogs_number",
		"title"			=> $lang->profileblogsNumberOfEntries,
		"description"	=> "",
		"optionscode"	=> "text",
		"value"			=> "5",
		"disporder"		=> "2",
		"gid"				=> intval($gid),
	);
	$db->insert_query("settings", $profileblogs_number);
	
	$profileblogs_imgwidth = array(
		"sid"				=> "NULL",
		"name"			=> "profileblogs_imgwidth",
		"title"			=> $lang->profileblogsPictureWidth,
		"description"	=> "",
		"optionscode"	=> "text",
		"value"			=> "100%",
		"disporder"		=> "3",
		"gid"				=> intval($gid),
	);
	$db->insert_query("settings", $profileblogs_imgwidth);
	
	$profileblogs_index = array(
		"sid"				=> "NULL",
		"name"			=> "profileblogs_index",
		"title"			=> $lang->profileblogsShowOnIndex,
		"description"	=> "",
		"optionscode"	=> "yesno",
		"value"			=> "1",
		"disporder"		=> "4",
		"gid"				=> intval($gid),
	);
	$db->insert_query("settings", $profileblogs_index);
	
	$profileblogs_indexname = array(
		"sid"				=> "NULL",
		"name"			=> "profileblogs_indexname",
		"title"			=> $lang->profileblogsWindowNameOnIndex,
		"description"	=> "",
		"optionscode"	=> "text",
		"value"			=> $lang->profileblogsWindowNameOnIndexValue,
		"disporder"		=> "5",
		"gid"				=> intval($gid),
	);
	$db->insert_query("settings", $profileblogs_indexname);
	
	$profileblogs_indexnumber = array(
		"sid"				=> "NULL",
		"name"			=> "profileblogs_indexnumber",
		"title"			=> $lang->profileblogsNumberOfEntriesOnIndex,
		"description"	=> "",
		"optionscode"	=> "text",
		"value"			=> "5",
		"disporder"		=> "6",
		"gid"				=> intval($gid),
	);
	$db->insert_query("settings", $profileblogs_indexnumber);
	
	$profileblogs_colornicks = array(
		"sid"				=> "NULL",
		"name"			=> "profileblogs_colornicks",
		"title"			=> $lang->profileblogsColorNicks,
		"description"	=> "",
		"optionscode"	=> "yesno",
		"value"			=> "1",
		"disporder"		=> "7",
		"gid"				=> intval($gid),
	);
	$db->insert_query("settings", $profileblogs_colornicks);
	
	$profileblogs_author = array(
		"sid"				=> "NULL",
		"name"			=> "profileblogs_author",
		"title"			=> $lang->profileblogsShowAuthor,
		"description"	=> $lang->profileblogsShowAuthorDesc,
		"optionscode"	=> "yesno",
		"value"			=> "1",
		"disporder"		=> "8",
		"gid"				=> intval($gid),
	);
	$db->insert_query("settings", $profileblogs_author);
	
	rebuild_settings();
}

function profileblogs_is_installed() {
	global $db;	
	if($db->table_exists("blogposts")) {
		return true;
	}
	else {
		return false;
	}
}

function profileblogs_uninstall() {
	global $db;
	$db->query("DROP TABLE `".TABLE_PREFIX."blogposts`");
	$db->query("DELETE FROM ".TABLE_PREFIX."settinggroups WHERE name='profileblogs'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='profileblogs_windowname'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='profileblogs_number'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='profileblogs_imgwidth'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='profileblogs_index'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='profileblogs_indexname'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='profileblogs_indexnumber'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='profileblogs_colornicks'");
	$db->query("DELETE FROM ".TABLE_PREFIX."settings WHERE name='profileblogs_author'");
	
	rebuild_settings();
}

function profileblogs_activate() {
	global $db;
	
	require MYBB_ROOT."/inc/adminfunctions_templates.php";
	find_replace_templatesets("member_profile", "#".preg_quote('{$profilefields}') . "#i", '{$profilefields} {$blog}');
	find_replace_templatesets("index", "#".preg_quote('{$boardstats}') . "#i", '{$latestblogs} {$boardstats}');
	
	// Aktualizacja do 1.1 :) Fix and upgrade
	if($db->table_exists("blogposts")) {
		$db->query("ALTER TABLE `".TABLE_PREFIX."blogposts` DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci");
		$db->query("ALTER TABLE `".TABLE_PREFIX."blogposts` CHANGE `subject` `subject` TEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL");
		$db->query("ALTER TABLE `".TABLE_PREFIX."blogposts` CHANGE `message` `message` TEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL");
		$db->query("ALTER TABLE `".TABLE_PREFIX."blogposts` CHANGE `ipaddress` `ipaddress` TEXT CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL");
	}
	
}

function profileblogs_deactivate() {
	require MYBB_ROOT."/inc/adminfunctions_templates.php";
	find_replace_templatesets("member_profile", "#".preg_quote('{$blog}') . "#i", "");
	find_replace_templatesets("index", "#".preg_quote('{$latestblogs}') . "#i", "");
}

// Generator tła komórki //////////////////////////////////////////////////////////////////////

function bgtrow() { // Generator tła komórki
	global $altbg;
	switch($altbg) {
		case "trow1":
			$altbg = "trow2";
			break;
		case "trow2":
			$altbg = "trow1";
			break;
		default:
			$altbg = "trow1";
			break;
	}
	return $altbg;
}

function profileblogs_box() {
	global $blog,$mybb,$db,$theme,$parser,$author_display,$lang;
	$lang->load("profileblogs");
		
// Początek tabeli //////////////////////////////////////////////////////////////////////

	switch($mybb->settings['profileblogs_author']) {
		case "1":
			$author_display = "inline";
			break;
		case "0":
			$author_display = "none";
			break;
		default:
			$author_display = "inline";
			break;
	}
	
	$blog = "<br /><a name=\"blog\"></a><table cellspacing=\"".$theme['borderwidth']."\" cellpadding=\"".$theme['tablespace']."\" class=\"tborder\" style=\"clear: both;\"><tr><td class=\"thead\"><strong>".$mybb->settings['profileblogs_windowname']."</strong><span style=\"display: ".$author_display."; float: right;\" class=\"smalltext\">".$lang->profileblogsAuthorNotice."</span></td></tr>";
	
// Aktualna strona ///////////////////////////////////////////////////////////////////////////////

	if(isset($mybb->input['blogpage'])) { 
		$blogpage = $mybb->input['blogpage'];
	}
	else {
		$blogpage = 1;
	}

// Edytowanie /////////////////////////////////////////////////////////////////////////

	if(isset($mybb->input['edit']) && ($mybb->input['uid'] == $mybb->user['uid'] or $mybb->usergroup['canmodcp'] == 1)) {
		$pid = $mybb->input['edit'];
		
		if(isset($mybb->input['subject'])) {
			$subject = addslashes($mybb->input['subject']);
			$message = addslashes($mybb->input['message']);
			
			$db->query("UPDATE `".TABLE_PREFIX."blogposts` SET `subject` = '".$subject."', `message` = '".$message."' WHERE `pid` = '".$pid."'");
		}
		
		else {
			$query = $db->query("SELECT * FROM `".TABLE_PREFIX."blogposts` WHERE `pid` = '".$pid."'");
			$entry = $db->fetch_array($query);
			$editsubject = $entry['subject'];
			$editmessage = $entry['message'];
		}
			
	}
	
// Dodawanie ///////////////////////////////////////////////////////////////////////////////

// Zapis do bazy ///////////////////////////////////////////////////////////////////////////////

	if(isset($mybb->input['subject']) && empty($mybb->input['edit']) && $mybb->input['uid'] == $mybb->user['uid']) {
		$uid = $mybb->user['uid'];
		$dateline = time();
		$subject = addslashes($mybb->input['subject']);
		$message = addslashes($mybb->input['message']);
		$ipaddress = $_SERVER['REMOTE_ADDR'];
		
		$db->query("INSERT INTO `".TABLE_PREFIX."blogposts` VALUES (NULL, '".$uid."', '".$dateline."', '".$subject."', '".$message."', '".$ipaddress."')");
		
	}
		

// Formularz ////////////////////////////////////////////////////////////////////////////////

	if($mybb->input['uid'] == $mybb->user['uid'] or (isset($mybb->input['edit']) && $mybb->usergroup['canmodcp'] == 1) && empty($mybb->input['subject'])) {
		$blog .= "<tr><td class=\"".bgtrow()."\">";
		
		if(isset($mybb->input['edit']) && empty($mybb->input['subject'])) {
			$blog .= "<form action=\"member.php?action=profile&amp;uid=".$mybb->input['uid']."&amp;edit=".$mybb->input['edit']."&amp;blogpage=".$blogpage."#blog\" method=\"post\">";
			$blog .= "<span style=\"float: left;\">".$lang->profileblogsEditEntry.":</span>";
		}
		else {
			$blog .= "<form action=\"member.php?action=profile&amp;uid=".$mybb->input['uid']."#blog\" method=\"post\">";
			$blog .= "<span style=\"float: left;\">".$lang->profileblogsNewEntry.":</span>";
		}
		
		$blog .= "<span style=\"float: right;\">".$lang->profileblogsSubject.": <input type=\"text\" name=\"subject\" maxlength=\"50\" value=\"".$editsubject."\" class=\"textbox\" /></span>";
		$blog .= "<br /><textarea name=\"message\" style=\"width: 99%; height: 60px;\">".$editmessage."</textarea>";
		$blog .= "<br /><input type=\"submit\" value=\"".$lang->profileblogsSave."\" style=\"float: right;\" />";
		$blog .= "</form></td></tr>";
	}
	
// Usuwanie /////////////////////////////////////////////////////////////////////

	if(isset($mybb->input['remove']) && ($mybb->input['uid'] == $mybb->user['uid'] or $mybb->usergroup['canmodcp'] == 1)) {
		$db->query("DELETE FROM `".TABLE_PREFIX."blogposts` WHERE `pid` = '".$mybb->input['remove']."'");
	}
		
// Wyświetlanie postów ////////////////////////////////////////////////////////////
	
	$start = (($blogpage-1)*($mybb->settings['profileblogs_number']));

	$parser_options = array(
		"allow_html" => 0,
		"allow_mycode" => 1,
		"allow_smilies" => 1,
		"allow_imgcode" => 1,
		"allow_videocode" => 1,
		"filter_badwords" => 1
	);

	$all = 0;
	$query = $db->query("SELECT * FROM `".TABLE_PREFIX."blogposts` WHERE `uid` = '".$mybb->input['uid']."' ORDER BY `dateline` DESC LIMIT ".$start.", ".$mybb->settings['profileblogs_number']);
	while($post = $db->fetch_array($query)) {
		$all++;
		$blog .= "<tr><td class=\"".bgtrow()."\">";
		$blog .= "<span class=\"smalltext\" style=\"float: right;\">".my_date($mybb->settings['dateformat'], $post['dateline'])." ";
		$blog .= my_date($mybb->settings['timeformat'], $post['dateline'])."</span>";
		$blog .= "<strong style=\"float: left;\">".$post['subject']."</strong><br />";
		$blog .=  str_replace("<img ", "<img style=\"max-width: ".$mybb->settings['profileblogs_imgwidth'].";\" ", $parser->parse_message($post['message'], $parser_options));
		if($mybb->input['uid'] == $mybb->user['uid'] or $mybb->usergroup['canmodcp'] == 1) {
			$blog .= "<br /><span class=\"smalltext\" style=\"float: right;\"><a href=\"member.php?action=profile&amp;uid=".$mybb->input['uid']."&amp;blogpage=".$blogpage."&amp;edit=".$post['pid']."#blog\">".$lang->profileblogsEdit."</a> | <a href=\"member.php?action=profile&amp;uid=".$mybb->input['uid']."&amp;blogpage=".$blogpage."&amp;remove=".$post['pid']."#blog\" onclick=\"return confirm('".$lang->profileblogsRemoveConfirm."');\">".$lang->profileblogsDelete."</a>";
			if($mybb->usergroup['canmodcp'] == 1) {
				$blog .= " | <a href=\"modcp.php?action=ipsearch&amp;perpage=20&amp;ipaddress=".$post['ipaddress']."&amp;search_users=1&amp;search_posts=1\">".$lang->profileblogsShowIP."</a>";
			}
		$blog .=	"</span>";
		}
		$blog .= "</td></tr>";
	}
	
	if($all == 0 && $mybb->input['uid'] != $mybb->user['uid'] && $blogpage == 1) {
		$blog .= "<tr><td class=\"".bgtrow()."\" style=\"text-align: center; padding: 20px 0px; font-style: italic;\">".$lang->profileblogsNoEntry."</td></tr>";
	}
	elseif($all == 0 && $blogpage > 1) {
		error($lang->error_invalidpost);
	}
	
// Paginacja //////////////////////////////////////////////////////////////////////////

	$query = $db->query("SELECT `pid` FROM `".TABLE_PREFIX."blogposts` WHERE `uid` = '".$mybb->input['uid']."'");
	$i = 0;
	while($db->fetch_array($query)) {
		$i++;
	}
	
	if($i > $mybb->settings['profileblogs_number']) {
		$blog .= "<tr><td class=\"tfoot\">";
		
		if($blogpage > 1) {
			$blog .= "<a href=\"member.php?action=profile&amp;uid=".$mybb->input['uid']."&amp;blogpage=".($blogpage-1)."#blog\" style=\"font-weight: bold; float: left;\">&laquo ".$lang->profileblogsNewer."</a>";	
		}
		if($blogpage < ceil($i/($mybb->settings['profileblogs_number']))) {
			$blog .= "<a href=\"member.php?action=profile&amp;uid=".$mybb->input['uid']."&amp;blogpage=".($blogpage+1)."#blog\" style=\"font-weight: bold; float: right;\">".$lang->profileblogsOlder." &raquo</a>";	
		}
		
		$blog .= "</td></tr>";
	}

// Zakończenie ////////////////////////////////////////////////////////////////////////
	
	$blog .= "</table>";
	
	eval("\$blog;");

}

function profileblogs_latest() {

	global $latestblogs,$mybb,$db,$theme,$lang,$author_display;
	$lang->load("profileblogs");
	
	switch($mybb->settings['profileblogs_author']) {
		case "1":
			$author_display = "inline";
			break;
		case "0":
			$author_display = "none";
			break;
		default:
			$author_display = "inline";
			break;
	}
	
if($mybb->settings['profileblogs_index'] == 1) {	
	
	$latestblogs = "<table cellspacing=\"".$theme['borderwidth']."\" cellpadding=\"".$theme['tablespace']."\" class=\"tborder\" style=\"clear: both;\"><tr><td class=\"thead\" colspan=\"6\"><strong>".$mybb->settings['profileblogs_indexname']."</strong><span style=\"display: ".$author_display."; float: right;\" class=\"smalltext\">".$lang->profileblogsAuthorNotice."</span></td></tr>";
	
	$latestblogs .= "<tr><td class=\"tcat\"><strong class=\"smalltext\">".$lang->profileblogsSubject."</td></strong><td class=\"tcat\" style=\"text-align: center;\"><strong class=\"smalltext\">".$lang->profileblogsDate."</strong></td><td class=\"tcat\" style=\"text-align: center;\"><strong class=\"smalltext\">".$lang->profileblogsAuthor."</strong></td><td class=\"tcat\"><strong class=\"smalltext\">".$lang->profileblogsSubject."</td></strong><td class=\"tcat\" style=\"text-align: center;\"><strong class=\"smalltext\">".$lang->profileblogsDate."</strong></td><td class=\"tcat\" style=\"text-align: center;\"><strong class=\"smalltext\">".$lang->profileblogsAuthor."</strong></td></tr>";
	
	function login($x) {
		global $mybb,$db;
			
		if($mybb->settings['profileblogs_colornicks'] == 1) {
			$first = $db->query("SELECT * FROM `".TABLE_PREFIX."users` WHERE `uid` = '".$x."'");
			$one = $db->fetch_array($first);
			$second = $db->query("SELECT * FROM `".TABLE_PREFIX."usergroups` WHERE `gid` = '".$one['usergroup']."'");
			$data = $db->fetch_array($second);
			$nick = str_replace("{username}", $one['username'], $data['namestyle']);
			return $nick;
		}
		else {
			$query = $db->query("SELECT `username` FROM `".TABLE_PREFIX."users`");
			$irryd = $db->fetch_array($query);
			return $irryd['username'];
		}
	}	
	
	$query = $db->query("SELECT * FROM `".TABLE_PREFIX."blogposts` ORDER BY `dateline` DESC LIMIT 0, ".$mybb->settings['profileblogs_indexnumber']);
	$h = 0;
	while($entry = $db->fetch_array($query)) {
		$h++;
		$background = bgtrow();
		if($h%2 != 0) {
			$latestblogs .= "<tr>";
		}
		$latestblogs .= "<td class=\"".$background."\"><a href=\"member.php?action=profile&amp;uid=".$entry['uid']."#blog\"><strong>".$entry['subject']."</strong></a></td><td class=\"".$background."\" style=\"text-align: center;\">".my_date($mybb->settings['dateformat'], $entry['dateline'])." ".my_date($mybb->settings['timeformat'], $entry['dateline'])."</td><td class=\"".$background."\"><a href=\"member.php?action=profile&amp;uid=".$entry['uid']."\">".login($entry['uid'])."</a></td>";
		if($h%2 == 0) {
			$latestblogs .= "</tr>";
			$background = bgtrow();
		}
	}
	if($h%2 != 0) {
		$latestblogs .= "<td class=\"".$background."\" colspan=\"3\"></td></tr>";
	}
	
	if($h == 0) {
		$latestblogs .= "<tr><td class=\"".bgtrow()."\" style=\"font-style: italic; text-align: center; padding: 10px 0px;\" colspan=\"6\">".$lang->profileblogsNoEntry."</td></tr>";
	}
	
	$latestblogs .= "</table><br />";
	
	eval("\$latestblogs;");
	
}	
	
}

?>